/**
 * Generated by Apache Royale Compiler from org/apache/royale/createjs/tween/Tween.as
 * org.apache.royale.createjs.tween.Tween
 *
 * @fileoverview
 *
 * @suppress {checkTypes|accessControls}
 */

goog.provide('org.apache.royale.createjs.tween.Tween');

goog.require('org.apache.royale.createjs.core.CreateJSBase');
goog.require('org.apache.royale.createjs.tween.Effect');
goog.require('org.apache.royale.core.IDocument');



/**
 * Constructor 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 1.0.0
 * @constructor
 * @extends {org.apache.royale.createjs.tween.Effect}
 * @implements {org.apache.royale.core.IDocument}
 * @param {Object=} target
 */
org.apache.royale.createjs.tween.Tween = function(target) {
  target = typeof target !== 'undefined' ? target : null;
  org.apache.royale.createjs.tween.Tween.base(this, 'constructor', target);
  
};
goog.inherits(org.apache.royale.createjs.tween.Tween, org.apache.royale.createjs.tween.Effect);


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.xFrom;


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.xTo;


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.yFrom;


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.yTo;


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.alphaFrom;


/**
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.alphaTo;


/**
 * @private
 * @type {Object}
 */
org.apache.royale.createjs.tween.Tween.prototype.org_apache_royale_createjs_tween_Tween_document;


/**
 * @param {Object} document
 * @param {string=} id
 */
org.apache.royale.createjs.tween.Tween.prototype.setDocument = function(document, id) {
  id = typeof id !== 'undefined' ? id : null;
  this.org_apache_royale_createjs_tween_Tween_document = document;
  
};


/**
 * @private
 * @type {createjs.Tween}
 */
org.apache.royale.createjs.tween.Tween.prototype.org_apache_royale_createjs_tween_Tween__tween;


/**
 * @asprivate
 * @royaleignorecoercion createjs.Shape
 * @royaleignorecoercion createjs.Tween
 * @royaleignorecoercion org.apache.royale.createjs.core.CreateJSBase
 * @override
 */
org.apache.royale.createjs.tween.Tween.prototype.createTweenOptions = function() {
  
  if (this.target != null) {
    this._actualTarget = this.org_apache_royale_createjs_tween_Tween_document[this.target];
  }
  var /** @type {createjs.Shape} */ element = this._actualTarget.element;
  var /** @type {Object} */ options = {};
  if (!isNaN(this.xTo))
    options["x"] = this.xTo;
  if (!isNaN(this.yTo))
    options["y"] = this.yTo;
  if (!isNaN(this.alphaTo))
    options["alpha"] = this.alphaTo;
  if (!isNaN(this.xFrom))
    this._actualTarget.x = this.xFrom;
  if (!isNaN(this.yFrom))
    this._actualTarget.y = this.yFrom;
  if (!isNaN(this.alphaFrom))
    this._actualTarget.alpha = this.alphaFrom;
  return options;
};


/**
 *  Causes the target object to move between its starting and ending positions. 
 *  
 *  @langversion 3.0
 *  @playerversion Flash 9
 *  @playerversion AIR 1.1
 *  @productversion Royale 1.0.0
 *  @royaleignorecoercion createjs.Shape
 *  @royaleignorecoercion createjs.Tween
 *  @royaleignorecoercion org.apache.royale.createjs.core.CreateJSBase
 * @override
 */
org.apache.royale.createjs.tween.Tween.prototype.play = function() {
  if (this.target != null) {
    this._actualTarget = this.org_apache_royale_createjs_tween_Tween_document[this.target];
  }
  var /** @type {createjs.Shape} */ element = this._actualTarget.element;
  this.org_apache_royale_createjs_tween_Tween__tween = createjs.Tween.get(element, {loop:this.loop});
  var /** @type {Object} */ options = this.createTweenOptions();
  this.org_apache_royale_createjs_tween_Tween__tween.to(options, this.duration, createjs.Ease.getPowInOut(2));
  var /** @type {createjs.Stage} */ stage = element.getStage();
  createjs.Ticker.addEventListener("tick", stage);
  
};


/**
 * Metadata
 *
 * @type {Object.<string, Array.<Object>>}
 */
org.apache.royale.createjs.tween.Tween.prototype.ROYALE_CLASS_INFO = { names: [{ name: 'Tween', qName: 'org.apache.royale.createjs.tween.Tween', kind: 'class' }], interfaces: [org.apache.royale.core.IDocument] };



/**
 * Reflection
 *
 * @return {Object.<string, Function>}
 */
org.apache.royale.createjs.tween.Tween.prototype.ROYALE_REFLECTION_INFO = function () {
  return {
    variables: function () {
      return {
        'xFrom': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.xFrom = v : inst.xFrom;}},
        'xTo': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.xTo = v : inst.xTo;}},
        'yFrom': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.yFrom = v : inst.yFrom;}},
        'yTo': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.yTo = v : inst.yTo;}},
        'alphaFrom': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.alphaFrom = v : inst.alphaFrom;}},
        'alphaTo': { type: 'Number', get_set: function (/** org.apache.royale.createjs.tween.Tween */ inst, /** * */ v) {return v !== undefined ? inst.alphaTo = v : inst.alphaTo;}}
      };
    },
    methods: function () {
      return {
        'Tween': { type: '', declaredBy: 'org.apache.royale.createjs.tween.Tween', parameters: function () { return [ 'Object', true ]; }},
        'setDocument': { type: 'void', declaredBy: 'org.apache.royale.createjs.tween.Tween', parameters: function () { return [ 'Object', false ,'String', true ]; }},
        'createTweenOptions': { type: 'Object', declaredBy: 'org.apache.royale.createjs.tween.Tween'},
        'play': { type: 'void', declaredBy: 'org.apache.royale.createjs.tween.Tween'}
      };
    }
  };
};
/**
 * @const
 * @type {number}
 */
org.apache.royale.createjs.tween.Tween.prototype.ROYALE_COMPILE_FLAGS = 10;